blob: 63476bb70b41ef3f90d4fe1649461ba7160787a6 [file] [log] [blame]
Jamey Sharp153f0112011-05-05 12:03:47 -07001#!/bin/sh
Linus Torvalds1da177e2005-04-16 15:20:36 -07002# Copyright (C) Martin Schlemmer <azarah@nosferatu.za.org>
Oleg Verychf6112ec2007-02-06 02:18:20 +01003# Copyright (C) 2006 Sam Ravnborg <sam@ravnborg.org>
Sam Ravnborgd39a206b2006-04-11 13:24:32 +02004#
Linus Torvalds1da177e2005-04-16 15:20:36 -07005# Released under the terms of the GNU GPL
6#
Sam Ravnborgd39a206b2006-04-11 13:24:32 +02007# Generate a cpio packed initramfs. It uses gen_init_cpio to generate
Masahiro Yamada65e00e02020-01-05 00:02:37 +09008# the cpio archive.
Sam Ravnborgd39a206b2006-04-11 13:24:32 +02009# This script assumes that gen_init_cpio is located in usr/ directory
10
11# error out on errors
12set -e
13
14usage() {
15cat << EOF
16Usage:
Masahiro Yamada96680972020-01-05 00:02:34 +090017$0 [-o <file>] [-l <dep_list>] [-u <uid>] [-g <gid>] {-d | <cpio_source>} ...
Masahiro Yamada65e00e02020-01-05 00:02:37 +090018 -o <file> Create initramfs file named <file> by using gen_init_cpio
Masahiro Yamada96680972020-01-05 00:02:34 +090019 -l <dep_list> Create dependency list named <dep_list>
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020020 -u <uid> User ID to map to user ID 0 (root).
Mike Frysinger4c6f2eb2007-05-10 22:44:28 -070021 <uid> is only meaningful if <cpio_source> is a
22 directory. "squash" forces all files to uid 0.
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020023 -g <gid> Group ID to map to group ID 0 (root).
Mike Frysinger4c6f2eb2007-05-10 22:44:28 -070024 <gid> is only meaningful if <cpio_source> is a
25 directory. "squash" forces all files to gid 0.
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020026 <cpio_source> File list or directory for cpio archive.
Oleg Verychf6112ec2007-02-06 02:18:20 +010027 If <cpio_source> is a .cpio file it will be used
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020028 as direct input to initramfs.
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020029
30All options except -o and -l may be repeated and are interpreted
31sequentially and immediately. -u and -g states are preserved across
32<cpio_source> options so an explicit "-u 0 -g 0" is required
33to reset the root/group mapping.
34EOF
35}
36
Oleg Verychf6112ec2007-02-06 02:18:20 +010037# awk style field access
38# $1 - field number; rest is argument string
39field() {
40 shift $1 ; echo $1
41}
42
Linus Torvalds1da177e2005-04-16 15:20:36 -070043filetype() {
44 local argv1="$1"
45
46 # symlink test must come before file test
47 if [ -L "${argv1}" ]; then
48 echo "slink"
49 elif [ -f "${argv1}" ]; then
50 echo "file"
51 elif [ -d "${argv1}" ]; then
52 echo "dir"
53 elif [ -b "${argv1}" -o -c "${argv1}" ]; then
54 echo "nod"
55 elif [ -p "${argv1}" ]; then
56 echo "pipe"
57 elif [ -S "${argv1}" ]; then
58 echo "sock"
59 else
60 echo "invalid"
61 fi
62 return 0
63}
64
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020065print_mtime() {
66 local my_mtime="0"
67
68 if [ -e "$1" ]; then
69 my_mtime=$(find "$1" -printf "%T@\n" | sort -r | head -n 1)
70 fi
71
Masahiro Yamada469e87e2020-01-05 00:02:36 +090072 echo "# Last modified: ${my_mtime}" >> $cpio_list
73 echo "" >> $cpio_list
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020074}
75
76list_parse() {
Masahiro Yamada96680972020-01-05 00:02:34 +090077 if [ -z "$dep_list" -o -L "$1" ]; then
Michal Marek590abbd2016-09-23 09:56:05 +020078 return
79 fi
Masahiro Yamada96680972020-01-05 00:02:34 +090080 echo "$1" | sed 's/:/\\:/g; s/$/ \\/' >> $dep_list
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020081}
82
83# for each file print a line in following format
84# <filetype> <name> <path to file> <octal mode> <uid> <gid>
85# for links, devices etc the format differs. See gen_init_cpio for details
Linus Torvalds1da177e2005-04-16 15:20:36 -070086parse() {
87 local location="$1"
Jamey Sharp153f0112011-05-05 12:03:47 -070088 local name="/${location#${srcdir}}"
Linus Torvalds1da177e2005-04-16 15:20:36 -070089 # change '//' into '/'
Jamey Sharp153f0112011-05-05 12:03:47 -070090 name=$(echo "$name" | sed -e 's://*:/:g')
Linus Torvalds1da177e2005-04-16 15:20:36 -070091 local mode="$2"
92 local uid="$3"
93 local gid="$4"
94 local ftype=$(filetype "${location}")
95 # remap uid/gid to 0 if necessary
Mike Frysinger4c6f2eb2007-05-10 22:44:28 -070096 [ "$root_uid" = "squash" ] && uid=0 || [ "$uid" -eq "$root_uid" ] && uid=0
97 [ "$root_gid" = "squash" ] && gid=0 || [ "$gid" -eq "$root_gid" ] && gid=0
Linus Torvalds1da177e2005-04-16 15:20:36 -070098 local str="${mode} ${uid} ${gid}"
99
Jamey Sharp153f0112011-05-05 12:03:47 -0700100 [ "${ftype}" = "invalid" ] && return 0
101 [ "${location}" = "${srcdir}" ] && return 0
Linus Torvalds1da177e2005-04-16 15:20:36 -0700102
103 case "${ftype}" in
104 "file")
105 str="${ftype} ${name} ${location} ${str}"
106 ;;
107 "nod")
Masahiro Yamadacc976612019-12-30 22:20:06 +0900108 local dev="`LC_ALL=C ls -l "${location}"`"
Oleg Verychf6112ec2007-02-06 02:18:20 +0100109 local maj=`field 5 ${dev}`
110 local min=`field 6 ${dev}`
111 maj=${maj%,}
Linus Torvalds1da177e2005-04-16 15:20:36 -0700112
Oleg Verychf6112ec2007-02-06 02:18:20 +0100113 [ -b "${location}" ] && dev="b" || dev="c"
114
115 str="${ftype} ${name} ${str} ${dev} ${maj} ${min}"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700116 ;;
117 "slink")
Felix Fietkaub5a5e4c2008-04-02 14:50:05 +0200118 local target=`readlink "${location}"`
Linus Torvalds1da177e2005-04-16 15:20:36 -0700119 str="${ftype} ${name} ${target} ${str}"
120 ;;
121 *)
122 str="${ftype} ${name} ${str}"
123 ;;
124 esac
125
Masahiro Yamada469e87e2020-01-05 00:02:36 +0900126 echo "${str}" >> $cpio_list
Linus Torvalds1da177e2005-04-16 15:20:36 -0700127
128 return 0
129}
130
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200131unknown_option() {
132 printf "ERROR: unknown option \"$arg\"\n" >&2
133 printf "If the filename validly begins with '-', " >&2
134 printf "then it must be prefixed\n" >&2
135 printf "by './' so that it won't be interpreted as an option." >&2
136 printf "\n" >&2
137 usage >&2
138 exit 1
Linus Torvalds1da177e2005-04-16 15:20:36 -0700139}
140
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200141header() {
Masahiro Yamada469e87e2020-01-05 00:02:36 +0900142 printf "\n#####################\n# $1\n" >> $cpio_list
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200143}
Linus Torvalds1da177e2005-04-16 15:20:36 -0700144
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200145# process one directory (incl sub-directories)
146dir_filelist() {
Masahiro Yamada96680972020-01-05 00:02:34 +0900147 header "$1"
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200148
149 srcdir=$(echo "$1" | sed -e 's://*:/:g')
Masahiro Yamada77a88272021-04-30 10:56:27 +0900150 dirlist=$(find "${srcdir}" -printf "%p %m %U %G\n" | LC_ALL=C sort)
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200151
152 # If $dirlist is only one line, then the directory is empty
153 if [ "$(echo "${dirlist}" | wc -l)" -gt 1 ]; then
Masahiro Yamada96680972020-01-05 00:02:34 +0900154 print_mtime "$1"
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200155
156 echo "${dirlist}" | \
157 while read x; do
Masahiro Yamada96680972020-01-05 00:02:34 +0900158 list_parse $x
159 parse $x
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200160 done
161 fi
162}
163
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200164input_file() {
165 source="$1"
166 if [ -f "$1" ]; then
Masahiro Yamada65e00e02020-01-05 00:02:37 +0900167 # If a regular file is specified, assume it is in
168 # gen_init_cpio format
Masahiro Yamada96680972020-01-05 00:02:34 +0900169 header "$1"
Masahiro Yamada469e87e2020-01-05 00:02:36 +0900170 print_mtime "$1" >> $cpio_list
171 cat "$1" >> $cpio_list
Masahiro Yamada96680972020-01-05 00:02:34 +0900172 if [ -n "$dep_list" ]; then
173 echo "$1 \\" >> $dep_list
Sam Ravnborg46ed9812006-04-30 23:56:33 +0200174 cat "$1" | while read type dir file perm ; do
Jamey Sharp153f0112011-05-05 12:03:47 -0700175 if [ "$type" = "file" ]; then
Masahiro Yamada96680972020-01-05 00:02:34 +0900176 echo "$file \\" >> $dep_list
Sam Ravnborg46ed9812006-04-30 23:56:33 +0200177 fi
178 done
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200179 fi
180 elif [ -d "$1" ]; then
Masahiro Yamada65e00e02020-01-05 00:02:37 +0900181 # If a directory is specified then add all files in it to fs
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200182 dir_filelist "$1"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700183 else
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200184 echo " ${prog}: Cannot open '$1'" >&2
Linus Torvalds1da177e2005-04-16 15:20:36 -0700185 exit 1
186 fi
187}
188
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200189prog=$0
Linus Torvalds1da177e2005-04-16 15:20:36 -0700190root_uid=0
191root_gid=0
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200192dep_list=
Masahiro Yamada469e87e2020-01-05 00:02:36 +0900193cpio_list=$(mktemp ${TMPDIR:-/tmp}/cpiolist.XXXXXX)
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200194output="/dev/stdout"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700195
Masahiro Yamada7168965e2020-01-05 00:02:38 +0900196trap "rm -f $cpio_list" EXIT
197
Linus Torvalds1da177e2005-04-16 15:20:36 -0700198while [ $# -gt 0 ]; do
199 arg="$1"
200 shift
201 case "$arg" in
Masahiro Yamada96680972020-01-05 00:02:34 +0900202 "-l") # files included in initramfs - used by kbuild
203 dep_list="$1"
204 echo "deps_initramfs := \\" > $dep_list
205 shift
206 ;;
Masahiro Yamada65e00e02020-01-05 00:02:37 +0900207 "-o") # generate cpio image named $1
208 output="$1"
Masahiro Yamada96680972020-01-05 00:02:34 +0900209 shift
210 ;;
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200211 "-u") # map $1 to uid=0 (root)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700212 root_uid="$1"
Rob Landley595a22a2017-07-06 15:35:43 -0700213 [ "$root_uid" = "-1" ] && root_uid=$(id -u || echo 0)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700214 shift
215 ;;
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200216 "-g") # map $1 to gid=0 (root)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700217 root_gid="$1"
Rob Landley595a22a2017-07-06 15:35:43 -0700218 [ "$root_gid" = "-1" ] && root_gid=$(id -g || echo 0)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700219 shift
220 ;;
Linus Torvalds1da177e2005-04-16 15:20:36 -0700221 "-h")
222 usage
223 exit 0
224 ;;
225 *)
226 case "$arg" in
227 "-"*)
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200228 unknown_option
Linus Torvalds1da177e2005-04-16 15:20:36 -0700229 ;;
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200230 *) # input file/dir - process it
Masahiro Yamada65e00e02020-01-05 00:02:37 +0900231 input_file "$arg"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700232 ;;
233 esac
234 ;;
235 esac
236done
237
Masahiro Yamada65e00e02020-01-05 00:02:37 +0900238# If output_file is set we will generate cpio archive
Lucas De Marchi25985ed2011-03-30 22:57:33 -0300239# we are careful to delete tmp files
Masahiro Yamada65e00e02020-01-05 00:02:37 +0900240timestamp=
241if test -n "$KBUILD_BUILD_TIMESTAMP"; then
242 timestamp="$(date -d"$KBUILD_BUILD_TIMESTAMP" +%s || :)"
243 if test -n "$timestamp"; then
244 timestamp="-t $timestamp"
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200245 fi
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200246fi
Masahiro Yamada65e00e02020-01-05 00:02:37 +0900247usr/gen_init_cpio $timestamp $cpio_list > $output